/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/ReplayCommand.h>

using namespace std;
using namespace activemq;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for ReplayCommand
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
ReplayCommand::ReplayCommand()
{
    this->firstNakNumber = 0;
    this->lastNakNumber = 0;
}

////////////////////////////////////////////////////////////////////////////////
ReplayCommand::~ReplayCommand()
{
}

////////////////////////////////////////////////////////////////////////////////
ReplayCommand* ReplayCommand::clone() const {
    ReplayCommand* replayCommand = new ReplayCommand();

    // Copy the data from the base class or classes
    BaseCommand::copy( replayCommand );

    replayCommand->firstNakNumber = this->getFirstNakNumber()->clone();
    replayCommand->lastNakNumber = this->getLastNakNumber()->clone();

    return replayCommand
}

////////////////////////////////////////////////////////////////////////////////
void ReplayCommand::copy( ReplayCommand* dest ) const {

    // Copy the data from the base class or classes
    BaseCommand::copy( replayCommand );

    dest->setFirstNakNumber( this->getFirstNakNumber()->clone() );
    dest->setLastNakNumber( this->getLastNakNumber()->clone() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char ReplayCommand::getDataStructureType() const {
    return ReplayCommand::ID_REPLAYCOMMAND; 
}

////////////////////////////////////////////////////////////////////////////////
const int ReplayCommand::getFirstNakNumber() const {
    return firstNakNumber;
}

////////////////////////////////////////////////////////////////////////////////
int ReplayCommand::getFirstNakNumber() {
    return firstNakNumber;
}

////////////////////////////////////////////////////////////////////////////////
void ReplayCommand::setFirstNakNumber(int firstNakNumber ) {
    this->firstNakNumber = firstNakNumber;
}

////////////////////////////////////////////////////////////////////////////////
const int ReplayCommand::getLastNakNumber() const {
    return lastNakNumber;
}

////////////////////////////////////////////////////////////////////////////////
int ReplayCommand::getLastNakNumber() {
    return lastNakNumber;
}

////////////////////////////////////////////////////////////////////////////////
void ReplayCommand::setLastNakNumber(int lastNakNumber ) {
    this->lastNakNumber = lastNakNumber;
}

