/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/DataArrayResponseMarshaller.h>

#include <activemq/connector/openwire/commands/DataArrayResponse.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* DataArrayResponseMarshaller::createObject() const {
    return new DataArrayResponse();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char DataArrayResponseMarshaller::getDataStructureType() const {
    return DataArrayResponse::ID_DATAARRAYRESPONSE;
}

///////////////////////////////////////////////////////////////////////////////
void DataArrayResponseMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   ResponseMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    DataArrayResponse* info =
        dynamic_cast<DataArrayResponse*>( dataStructure );

    if( bs->readBoolean() ) {
        short size = dataIn->readShort();
        DataStructure* value = new DataStructure[size];
        for( int i = 0; i < size; i++ ) {
            value[i] = dynamic_cast< DataStructure* >(
                tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
        }
        info->setData( value );
    }
    else {
        info->setData( NULL );
    }
}

///////////////////////////////////////////////////////////////////////////////
int DataArrayResponseMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    DataArrayResponse* info =
        dynamic_cast<DataArrayResponse*>( dataStructure );

    int rc = ResponseMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    rc += tightMarshalObjectArray1( wireFormat, info->getData(), bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void DataArrayResponseMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    ResponseMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    DataArrayResponse* info =
        dynamic_cast<DataArrayResponse*>( dataStructure );
    tightMarshalObjectArray2( wireFormat, info->getData(), dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void DataArrayResponseMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    ResponseMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    DataArrayResponse* info = 
        dynamic_cast<DataArrayResponse*>( dataStructure );

    if( dataIn->readBoolean() ) {
        short size = dataIn->readShort();
        DataStructure* value = new DataStructure[size];
        for( int i = 0; i < size; i++ ) {
            value[i] = dynamic_cast<DataStructure* >(
                looseUnmarshalNestedObject( wireFormat,dataIn ) );
        }
        info->setData( value );
    }
    else {
        info->setData( NULL );
    }
}

///////////////////////////////////////////////////////////////////////////////
void DataArrayResponseMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    DataArrayResponse* info =
        dynamic_cast<DataArrayResponse*>( dataStructure );
    ResponseMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    looseMarshalObjectArray( wireFormat, info->getData(), dataOut );
}

