/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/ExceptionResponseMarshaller.h>

#include <activemq/connector/openwire/commands/ExceptionResponse.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* ExceptionResponseMarshaller::createObject() const {
    return new ExceptionResponse();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char ExceptionResponseMarshaller::getDataStructureType() const {
    return ExceptionResponse::ID_EXCEPTIONRESPONSE;
}

///////////////////////////////////////////////////////////////////////////////
void ExceptionResponseMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   ResponseMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    ExceptionResponse* info =
        dynamic_cast<ExceptionResponse*>( dataStructure );
    info->setException( dynamic_cast< Throwable* >(
        tightUnmarsalThrowable( wireFormat, dataIn, bs ) );
}

///////////////////////////////////////////////////////////////////////////////
int ExceptionResponseMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    ExceptionResponse* info =
        dynamic_cast<ExceptionResponse*>( dataStructure );

    int rc = ResponseMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    rc += tightMarshalBrokerError1( wireFormat, info->getException(), bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void ExceptionResponseMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    ResponseMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    ExceptionResponse* info =
        dynamic_cast<ExceptionResponse*>( dataStructure );
    tightMarshalBrokerError2( wireFormat, info->getException(), dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void ExceptionResponseMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    ResponseMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    ExceptionResponse* info = 
        dynamic_cast<ExceptionResponse*>( dataStructure );
    info->setException( looseUnmarshalBrokerError( wireFormat, dataIn ) );
}

///////////////////////////////////////////////////////////////////////////////
void ExceptionResponseMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    ExceptionResponse* info =
        dynamic_cast<ExceptionResponse*>( dataStructure );
    ResponseMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    looseMarshalBrokerError( wireFormat, info->getException(), dataOut );
}

