/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/JournalTransactionMarshaller.h>

#include <activemq/connector/openwire/commands/JournalTransaction.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* JournalTransactionMarshaller::createObject() const {
    return new JournalTransaction();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char JournalTransactionMarshaller::getDataStructureType() const {
    return JournalTransaction::ID_JOURNALTRANSACTION;
}

///////////////////////////////////////////////////////////////////////////////
void JournalTransactionMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   BaseDataStreamMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    JournalTransaction* info =
        dynamic_cast<JournalTransaction*>( dataStructure );
    info->setTransactionId( dynamic_cast< TransactionId* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
    info->setType( dataIn->readByte() );
    info->setWasPrepared( bs->readBoolean() );
}

///////////////////////////////////////////////////////////////////////////////
int JournalTransactionMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    JournalTransaction* info =
        dynamic_cast<JournalTransaction*>( dataStructure );

    int rc = BaseDataStreamMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );
    bs->writeBoolean( info->getWasPrepared() );

    return rc + 1;
}

///////////////////////////////////////////////////////////////////////////////
void JournalTransactionMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    BaseDataStreamMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    JournalTransaction* info =
        dynamic_cast<JournalTransaction*>( dataStructure );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
    dataOut->write( info->getType() );
    bs->readBoolean();
}

///////////////////////////////////////////////////////////////////////////////
void JournalTransactionMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    BaseDataStreamMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    JournalTransaction* info = 
        dynamic_cast<JournalTransaction*>( dataStructure );
   info->setTransactionId( dynamic_cast<TransactionId* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
    info->setType( dataIn->readByte() );
    info->setWasPrepared( dataIn->readBoolean() );
}

///////////////////////////////////////////////////////////////////////////////
void JournalTransactionMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    JournalTransaction* info =
        dynamic_cast<JournalTransaction*>( dataStructure );
    BaseDataStreamMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
    dataOut->write( info->getType() );
    dataOut->write( info->getWasPrepared() );
}

