/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/NetworkBridgeFilterMarshaller.h>

#include <activemq/connector/openwire/commands/NetworkBridgeFilter.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* NetworkBridgeFilterMarshaller::createObject() const {
    return new NetworkBridgeFilter();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char NetworkBridgeFilterMarshaller::getDataStructureType() const {
    return NetworkBridgeFilter::ID_NETWORKBRIDGEFILTER;
}

///////////////////////////////////////////////////////////////////////////////
void NetworkBridgeFilterMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   BaseDataStreamMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    NetworkBridgeFilter* info =
        dynamic_cast<NetworkBridgeFilter*>( dataStructure );
    info->setNetworkTTL( dataIn->readInt() );
    info->setNetworkBrokerId( dynamic_cast< BrokerId* >(
        tightUnmarsalCachedObject( wireFormat, dataIn, bs ) );
}

///////////////////////////////////////////////////////////////////////////////
int NetworkBridgeFilterMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    NetworkBridgeFilter* info =
        dynamic_cast<NetworkBridgeFilter*>( dataStructure );

    int rc = BaseDataStreamMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getNetworkBrokerId() );

    rc += tightMarshalCachedObject1( wireFormat, data, bs );

    return rc + 4;
}

///////////////////////////////////////////////////////////////////////////////
void NetworkBridgeFilterMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    BaseDataStreamMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    NetworkBridgeFilter* info =
        dynamic_cast<NetworkBridgeFilter*>( dataStructure );
    dataOut->write( info->getNetworkTTL() );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getNetworkBrokerId() );

    tightMarshalCachedObject2( wireFormat, data, dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void NetworkBridgeFilterMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    BaseDataStreamMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    NetworkBridgeFilter* info = 
        dynamic_cast<NetworkBridgeFilter*>( dataStructure );
    info->setNetworkTTL( dataIn->readInt() );
   info->setNetworkBrokerId( dynamic_cast<BrokerId* >( 
       looseUnmarshalCachedObject( wireFormat, dataIn ) ) );
}

///////////////////////////////////////////////////////////////////////////////
void NetworkBridgeFilterMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    NetworkBridgeFilter* info =
        dynamic_cast<NetworkBridgeFilter*>( dataStructure );
    BaseDataStreamMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    dataOut->write( info->getNetworkTTL() );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getNetworkBrokerId() );

    looseMarshalCachedObject( wireFormat, data, dataOut );
}

