/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/SessionIdMarshaller.h>

#include <activemq/connector/openwire/commands/SessionId.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* SessionIdMarshaller::createObject() const {
    return new SessionId();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char SessionIdMarshaller::getDataStructureType() const {
    return SessionId::ID_SESSIONID;
}

///////////////////////////////////////////////////////////////////////////////
void SessionIdMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   BaseDataStreamMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    SessionId* info =
        dynamic_cast<SessionId*>( dataStructure );
    info->setConnectionId( TightUnmarshalString( dataIn, bs ) );
    info->setValue( TightUnmarshalLong( wireFormat, dataIn, bs ) );
}

///////////////////////////////////////////////////////////////////////////////
int SessionIdMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    SessionId* info =
        dynamic_cast<SessionId*>( dataStructure );

    int rc = BaseDataStreamMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    rc += tightMarshalString1( info->getConnectionId(), bs );
    rc += tightMarshalLong1( wireFormat, info->getValue(), bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void SessionIdMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    BaseDataStreamMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    SessionId* info =
        dynamic_cast<SessionId*>( dataStructure );
    tightMarshalString2( info->getConnectionId(), dataOut, bs );
    tightMarshalLong2( wireFormat, info->getValue(), dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void SessionIdMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    BaseDataStreamMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    SessionId* info = 
        dynamic_cast<SessionId*>( dataStructure );
    info->setConnectionId( looseUnmarshalString( dataIn ) );
    info->setValue( looseUnmarshalLong( wireFormat, dataIn ) );
}

///////////////////////////////////////////////////////////////////////////////
void SessionIdMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    SessionId* info =
        dynamic_cast<SessionId*>( dataStructure );
    BaseDataStreamMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    looseMarshalString( info->getConnectionId(), dataOut );
    looseMarshalLong( wireFormat, info->getValue(), dataOut );
}

