/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef ACTIVEMQ_UTIL_CONFIG_H_
#define ACTIVEMQ_UTIL_CONFIG_H_

//
// The purpose of this header is to try to detect the supported headers 
// of the platform when the ./configure script is not being used to generate
// the config.h file.
//
#if defined(HAVE_CONFIG_H) 

	// config.h is generated by the ./configure script and it only 
	// used by unix like systems (includeing cygwin)
	#include <config.h>


#else /* !defined(HAVE_CONFIG_H) */

	// Not using ./configure script and make system.. chances are your using the native build tools
	// of Windows or OS X to do this build
   #if defined(__APPLE__)
      #define HAVE_UUID_UUID_H
	#elif defined(_WIN32) || defined( __CYGWIN__ )
		#define HAVE_OBJBASE_H
		#define HAVE_RPCDCE_H
		#define HAVE_WINSOCK2_H
        #define HAVE_STRUCT_ADDRINFO
	#elif defined( unix )
		#define HAVE_UUID_UUID_H
	#else
		#error "Unknown Platform"
	#endif

#endif /* !defined(HAVE_CONFIG_H) */


#endif /*ACTIVEMQ_UTIL_CONFIG_H_*/
